// |-------------------------------------------|
// | 4 battle songs and 4 victory fanfare hack |
// | by: madsiur 							   |
// | version: 1.0 							   |
// | released on: January 16th, 2022           |
// | apply to: FF3us 1.0 (no header)           |
// |-------------------------------------------|

arch snes.cpu

macro seek(variable offset) {
  origin (offset & $3FFFFF)
  base offset
}

// victory fanfare hook
seek($C10152)
jsl sub_C10152_EX
nop

// battle theme hook
seek($C2BDB7)
jsl sub_C2BDB7_EX

// relocated resumed songs table
seek($C5062B)
lda.l resumed_songs,x

// relocated instrument data
seek($C501E2)
lda.l instrument_data,x

// total number of songs
seek($C53C5E)
db $5B

// new song pointers
seek($C53F95)
dl song_0
dl song_1
dl song_2
dl fanfare_0
dl fanfare_1
dl fanfare_2

// new battle song code
seek($FF0000)			// you can change this free space offset
scope sub_C2BDB7_EX: {
lda.l $C2BF3B,x         // load song ID
cmp.b #$24              // compare to battle theme
bne exit                // exit if not battle them
inc $BE
ldx $BE
lda $C0FD00,x           // choose a random number from 0 to 255
and #$03				// index 0 to 3
tax
lda.l song_table,x      // load replacement song
exit:
rtl

// the 4 battle songs
song_table:
db $55                  // FF7: Let the Battle Begin!
db $56                  // FF9: Battle 1
db $57                  // ToP: Battle Theme
db $24					// FF6: Battle Theme
}

// new victory fanfare code
scope sub_C10152_EX: {
inc $BE
ldx $BE
lda $C0FD00,x           // choose a random number from 0 to 255
and #$03				// index 0 to 3
tax
lda.l fanfare_table,x   // load replacement song
sta.w $1301
rtl

// the 4 victory fanfare
fanfare_table:
db $58                  // Chrono Cross: Victory Fanfare
db $59                  // Chrono Trigger: Victory Fanfare
db $5A                  // Mystic Quest: Victory!
db $2F					// FF6: Fanfare
}

// map song will resume after these
resumed_songs:
db $24					// FF6: Battle Theme
db $38
db $14
db $33
db $55                  // FF7: Let the Battle Begin!
db $56                  // FF9: Battle 1
db $57                  // ToP: Battle Theme
db $FF					// end of table

// relocated and new instrument sets
instrument_data:
insert "bins/instrument_data.bin"
insert "bins/song_0_inst.bin"
insert "bins/song_1_inst.bin"
insert "bins/song_2_inst.bin"
insert "bins/fanfare_0_inst.bin"
insert "bins/fanfare_1_inst.bin"
insert "bins/fanfare_2_inst.bin"

// new song data
song_0:
insert "bins/song_0_data.bin"
song_1:
insert "bins/song_1_data.bin"
song_2:
insert "bins/song_2_data.bin"
fanfare_0:
insert "bins/fanfare_0_data.bin"
fanfare_1:
insert "bins/fanfare_1_data.bin"
fanfare_2:
insert "bins/fanfare_2_data.bin"